Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java	(revision 527)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java	(revision 528)
@@ -2,7 +2,11 @@
 
 import java.awt.Font;
 import java.awt.GraphicsEnvironment;
+import java.util.ArrayList;
 
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.preference.ComboFieldEditor;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
@@ -10,6 +14,7 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.ToolBar;
 import org.eclipse.swt.widgets.ToolItem;
+import org.txm.chartsengine.core.ChartCreator;
 import org.txm.chartsengine.core.ChartsEngine;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
@@ -166,32 +171,76 @@
 		fontSizeCombo.select(currentFontSizeIndex);
 
 		
+		// Chart types from installed chart creators
 		
+//		if(contributions.length > 1)	{
+			final Combo chartTypeCombo = new Combo(this, SWT.READ_ONLY);
+			ArrayList<ChartCreator> chartCreators = this.chartEditorPart.getSWTChartsComponentsProvider().getChartsEngine().getChartCreators(this.chartEditorPart.getResultData());
+			String chartTypes[] = new String[chartCreators.size()];
+			int currentChartTypeIndex = 0;
+			for(int i = 0; i < chartCreators.size(); i++) {
+				chartTypes[i] = chartCreators.get(i).getChartType();
+				if(chartTypes[i] == null)	{
+					chartTypes[i] = this.chartEditorPart.getResultData().getClass().getName();
+				}
+				if(this.getEditorPart().getChartType() != null && this.getEditorPart().getChartType().equals(chartTypes[i])) {
+					currentChartTypeIndex = i;
+				}
+				
+			}
+			chartTypeCombo.setItems(chartTypes);
+			
+			ToolItem chartTypeComboItem = new ToolItem(this, SWT.SEPARATOR);
+			chartTypeComboItem.setControl(chartTypeCombo);
+			chartTypeCombo.pack();
+			chartTypeComboItem.setWidth(chartTypeCombo.getBounds().width);
+			
+			chartTypeCombo.select(currentChartTypeIndex);
+			
+			
+			if(chartCreators.size() < 2)	{
+				chartTypeCombo.setVisible(false);
+			}
+//		}
+//		else	{
+//			final Combo chartTypeCombo = null;
+//		}
+		
+		
+		
+		
 		// Listeners
 		SelectionListener listener = new SelectionListener() {
 			
 			@Override
 			public void widgetSelected(final SelectionEvent e) {
 				
+				boolean update = true;
+				
 				// Accessing the source must be done outside the Job
 				if(e.getSource() == showTitle)	{
-					TXMPreferences.putLocalBoolean(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_TITLE, showTitle.getSelection());
+					TXMPreferences.putLocal(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_TITLE, showTitle.getSelection());
 				}
 				else if(e.getSource() == showLegend)	{
-					TXMPreferences.putLocalBoolean(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_LEGEND, showLegend.getSelection());
+					TXMPreferences.putLocal(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_LEGEND, showLegend.getSelection());
 				}
 				else if(e.getSource() == showGrid)	{
-					TXMPreferences.putLocalBoolean(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_GRID, showGrid.getSelection());
+					TXMPreferences.putLocal(chartEditorPart.getResultData(), ChartsEnginePreferences.SHOW_GRID, showGrid.getSelection());
 				}
 				else if(e.getSource() == renderingModeCombo)	{
-					TXMPreferences.putLocalInt(chartEditorPart.getResultData(), ChartsEnginePreferences.RENDERING_COLORS_MODE, renderingModeCombo.getSelectionIndex());
+					TXMPreferences.putLocal(chartEditorPart.getResultData(), ChartsEnginePreferences.RENDERING_COLORS_MODE, renderingModeCombo.getSelectionIndex());
 				}
 				else if(e.getSource() == fontCombo || e.getSource() == fontSizeCombo)	{
-					TXMPreferences.putLocalString(chartEditorPart.getResultData(), ChartsEnginePreferences.FONT, "1|" + fontCombo.getItem(fontCombo.getSelectionIndex()) + "|" + fontSizeCombo.getItem(fontSizeCombo.getSelectionIndex()) + "|0");
+					TXMPreferences.putLocal(chartEditorPart.getResultData(), ChartsEnginePreferences.FONT, "1|" + fontCombo.getItem(fontCombo.getSelectionIndex()) + "|" + fontSizeCombo.getItem(fontSizeCombo.getSelectionIndex()) + "|0");
 				}
+				else if(e.getSource() == chartTypeCombo)	{
+					chartEditorPart.getResultData().setChartType(chartTypeCombo.getItem(chartTypeCombo.getSelectionIndex()));
+					update = false;
+				}
+
 				
 				// updates existing chart
-				chartEditorPart.computeChart("Update chart", true);
+				chartEditorPart.computeChart("Update chart", update);
 			}
 			
 			@Override
@@ -206,6 +255,7 @@
 		renderingModeCombo.addSelectionListener(listener);
 		fontCombo.addSelectionListener(listener);
 		fontSizeCombo.addSelectionListener(listener);
+		chartTypeCombo.addSelectionListener(listener);
 	}
 
 
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java	(revision 527)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java	(revision 528)
@@ -11,6 +11,7 @@
  * @author sjacquot
  *
  */
+// FIXME: became useless, can directly use TXMEditorToolBar
 public class ChartEditorToolBar extends TXMEditorToolBar {
 
 	
Index: tmp/org.txm.internalview.core/src/org/txm/functions/internal/InternalView.java
===================================================================
--- tmp/org.txm.internalview.core/src/org/txm/functions/internal/InternalView.java	(revision 527)
+++ tmp/org.txm.internalview.core/src/org/txm/functions/internal/InternalView.java	(revision 528)
@@ -7,7 +7,6 @@
 import java.util.LinkedHashMap;
 import java.util.List;
 
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
 import org.txm.internalview.core.Messages;
@@ -214,12 +213,12 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 		return corpus != null && pStructure != null && pProperties != null && pProperties.size() > 0 && pStructProperties != null && pStructProperties.size() > 0;
 	}
 
 	@Override
-	public boolean _compute() throws Exception {
+	protected boolean _compute(boolean update) throws Exception {
 		//find struct start-end
 		Query query = new Query("<"+pStructure.getName()+"> [] expand to "+pStructure); //$NON-NLS-1$ //$NON-NLS-2$
 		//System.out.println(query);
Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java	(revision 527)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java	(revision 528)
@@ -217,7 +217,7 @@
 				final TextsBalance textsBalance = (TextsBalance)getResultData();
 				try {
 					textsBalance.setParameters(method, su, propertyName, groupByTexts);
-					textsBalance.compute(monitor);
+					textsBalance.compute(false, monitor);
 				}
 				catch(Exception e) {
 					System.out.println("Error: "+e.getLocalizedMessage());
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 527)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 528)
@@ -11,12 +11,11 @@
 import org.jfree.data.xy.XYSeries;
 import org.jfree.data.xy.XYSeriesCollection;
 import org.txm.chartsengine.core.ChartsEngine;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.core.results.TXMResult;
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 import org.txm.chartsengine.jfreechart.core.renderers.interfaces.IRendererWithItemSelection;
 import org.txm.chartsengine.jfreechart.core.themes.base.ExtendedNumberAxis;
 import org.txm.chartsengine.jfreechart.core.themes.base.SymbolAxisBetweenTicks;
+import org.txm.core.results.TXMResult;
 import org.txm.partition.core.chartsengine.base.Utils;
 import org.txm.partition.core.functions.PartitionDimensions;
 import org.txm.partition.core.messages.PartitionCoreMessages;
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java	(revision 527)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java	(revision 528)
@@ -4,10 +4,9 @@
 import java.util.List;
 
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.core.results.TXMResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 import org.txm.chartsengine.r.core.RChartsEngine;
+import org.txm.core.results.TXMResult;
 import org.txm.partition.core.chartsengine.base.Utils;
 import org.txm.partition.core.functions.PartitionDimensions;
 import org.txm.partition.core.messages.PartitionCoreMessages;
@@ -22,14 +21,6 @@
  */
 public class RPartitionDimensionsBarChartCreator extends RChartCreator {
 
-	public RPartitionDimensionsBarChartCreator() {
-	}
-
-	@Override
-	public Object createChart(TXMResult result) {
-		return null;
-	}
-
 	
 	@Override
 	public File createChartFile(TXMResult result, File file) {
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java	(revision 527)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java	(revision 528)
@@ -22,14 +22,6 @@
  */
 public class RPartitionDimensionsPieChartCreator extends RChartCreator {
 
-	public RPartitionDimensionsPieChartCreator() {
-	}
-
-	@Override
-	public Object createChart(TXMResult result) {
-		return null;
-	}
-
 	
 	@Override
 	public File createChartFile(TXMResult result, File file) {
Index: tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 527)
+++ tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 528)
@@ -41,7 +41,6 @@
 import java.util.Map;
 import java.util.Set;
 
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.rosuda.REngine.REXPMismatchException;
 import org.txm.concordance.core.functions.Concordance;
 import org.txm.concordance.core.functions.Line;
@@ -50,7 +49,6 @@
 import org.txm.cooccurrence.core.preferences.CooccurrencePreferences;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
-
 import org.txm.index.core.functions.Index;
 import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
@@ -445,7 +443,7 @@
 	 * @param buildLexicalTableWithCooccurrents
 	 * @return
 	 */
-	public boolean _compute() {
+	protected boolean _compute(boolean update) {
 		this.monitor = monitor;
 		//FIXME: debug
 		//System.out.println("cooc: "+corpus+" "+query+" "+properties+" "+limit+" "+maxLeft+" "+minLeft+" "+minRight+" "+maxRight+" "+minFreq+" "+minCof+" "+minScore+" "+includeXpivot);
@@ -1058,7 +1056,7 @@
 			try {
 				voc = new Index(corpus);
 				voc.setParameters(new Query(pCooccurentQueryFilter), pProperties, null, null, null, null);
-				voc.compute(monitor);
+				voc.compute(false, monitor);
 			} catch (Exception e){
 				Log.severe("Error while computing Index for the cooccurrence: "+e.getLocalizedMessage());
 				return false;
@@ -1546,7 +1544,7 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 
 		boolean ret = pQuery != null && pProperties != null && getCorpus() != null && pQuery.getQueryString().length() > 0 && pProperties.size() > 0;
 
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 527)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 528)
@@ -37,10 +37,9 @@
 import java.util.List;
 import java.util.Map;
 
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.core.results.TXMParameters;
-import org.txm.core.results.TXMResult;
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.progression.core.messages.ProgressionCoreMessages;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
@@ -60,10 +59,12 @@
  * @author mdecorde
  * @author sjacquot
  */
-public class Progression extends TXMResult	{
+public class Progression extends ChartResult	{
 
-	/** The corpus. */
-	Corpus corpus;
+	/**
+	 * The corpus.
+	 */
+	protected Corpus corpus;
 
 	/** The queries. */
 	List<Query> queries;
@@ -112,6 +113,17 @@
 	/** The bandemultiplier. */
 	private float bandemultiplier;
 
+	
+	/** The norep. */
+	public static int norep = 1;
+
+	/** The prefix r. */
+	public static String prefixR = "Progression"; //$NON-NLS-1$
+
+
+
+	
+	
 	/**
 	 * Instantiates a new progression.
 	 *
@@ -150,16 +162,42 @@
 		}
 	}
 
+	
 	/**
-	 * Compute.
+	 * Computes.
 	 *
 	 * @return true, if successful
 	 * @throws CqiClientException the cqi client exception
 	 * @throws CqiServerError 
 	 * @throws IOException 
 	 */
-	public boolean _compute() throws Exception {
-		return stepQueries() && stepStructuralUnits() && stepFinalize();
+	protected boolean _compute(boolean update) throws Exception {
+		
+		this.subTask("processing queries");
+		if (!stepQueries()) {
+			System.out.println(ProgressionCoreMessages.ComputeProgression_3);
+			return false;
+		}
+		
+		if (this.isCanceled())	{
+			return false;
+		}
+		this.worked(10);
+
+		
+		this.subTask("processing structural units");
+		if (!stepStructuralUnits() || this.isCanceled())	{
+			return false;
+		}
+		this.worked(20);
+
+		this.subTask("finalizing");
+		if (!stepFinalize() || this.isCanceled())	{
+			return false;
+		}
+		this.worked(20);
+
+		return true;
 	}
 
 	/**
@@ -194,8 +232,7 @@
 	 *
 	 * @throws CqiClientException the cqi client exception
 	 */
-	public boolean stepQueries() throws CqiClientException
-	{
+	public boolean stepQueries() throws CqiClientException	{
 		maxX = corpus.getSize();
 		int npositions = 0;
 		for (Query query : queries) {
@@ -222,8 +259,16 @@
 			for (Match m : matches) {
 				positions[i++] = m.getStart();
 				npositions++;
+				this.worked(1);
+				
+				// FIXME: long process test for Thread user canceling
+				System.err.println("Progression.stepQueries(): fixme: simulating a long process for canceling tests purpose.");
+				for(long j = 0; j < 100000000L; j++)	{
+					;
+				}
+
+				
 			}
-			result.drop();
 		}
 		return npositions > 0;
 	}
@@ -235,8 +280,7 @@
 	 * @throws CqiServerError 
 	 * @throws IOException 
 	 */
-	public boolean stepStructuralUnits() throws CqiClientException, IOException, CqiServerError
-	{
+	public boolean stepStructuralUnits() throws CqiClientException, IOException, CqiServerError	{
 		// structure query
 		if (structure != null) {
 			Query query = new Query("<" + structure.getName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -313,8 +357,7 @@
 	 *
 	 * @throws CqiClientException the cqi client exception
 	 */
-	public boolean stepFinalize() throws CqiClientException
-	{
+	public boolean stepFinalize() throws CqiClientException	{
 		if (corpus instanceof Subcorpus) {
 			List<Match> matches = ((Subcorpus) corpus).getMatches();
 			if (matches.size() == 0) {
@@ -338,13 +381,6 @@
 		return true;
 	}
 
-	/** The norep. */
-	public static int norep = 1;
-
-	/** The prefix r. */
-	public static String prefixR = "Progression"; //$NON-NLS-1$
-
-
 	/**
 	 * 
 	 * @param outfile
@@ -597,7 +633,9 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
+		// FIXME: not yet implemented
+		System.err.println("Progression.canCompute(): not yet implemented.");
 		return corpus != null;
 	}
 
Index: tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/functions/TextsBalance.java
===================================================================
--- tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/functions/TextsBalance.java	(revision 527)
+++ tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/functions/TextsBalance.java	(revision 528)
@@ -10,12 +10,8 @@
 import java.util.HashMap;
 import java.util.List;
 
-import org.txm.Toolbox;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.core.results.TXMResult;
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.core.results.TXMParameters;
-
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.searchengine.cqp.AbstractCqiClient;
 import org.txm.searchengine.cqp.CQPEngine;
 import org.txm.searchengine.cqp.NetCqiClient;
@@ -36,7 +32,7 @@
  * @author sjacquot
  *
  */
-public class TextsBalance extends TXMResult {
+public class TextsBalance extends ChartResult {
 	
 	HashMap<Integer, Comparable[]> dataset;
 	
@@ -99,7 +95,7 @@
 	 * @param groupByTexts
 	 * @throws CqiClientException
 	 */
-	public boolean _compute() {
+	protected boolean _compute(boolean update) {
 		
 		this.name = su.getName() + "@" + suPropertyName + " (group by texts = " + groupByTexts + ")";
 		if (suPropertyName == null || suPropertyName.length() == 0) return false;
@@ -307,7 +303,7 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 		return getCorpus() != null;
 	}
 }
Index: tmp/org.txm.concordance.core/src/TestConcordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/TestConcordance.java	(revision 527)
+++ tmp/org.txm.concordance.core/src/TestConcordance.java	(revision 528)
@@ -104,7 +104,7 @@
 					leftCViewProperties, rightCViewProperties, keywordViewProperties,
 					referencePattern, refAnalysePattern, 
 					leftContextSize, rightContextSize);
-			conc.compute();
+			conc.compute(false);
 			conc.getLines(0, conc.getNLines());
 			
 			if (sortBy != null) {
Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 527)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 528)
@@ -42,7 +42,6 @@
 import java.util.List;
 import java.util.Map;
 
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.concordance.core.functions.comparators.LineComparator;
 import org.txm.concordance.core.messages.ConcordanceMessages;
 import org.txm.concordance.core.preferences.ConcordancePreferences;
@@ -264,7 +263,7 @@
 	 * @throws CqiClientException 
 	 */
 	@Override
-	public boolean _compute() throws Exception {
+	protected boolean _compute(boolean update) throws Exception {
 		this.queryResult = this.getCorpus().query(pQuery, pQuery.getQueryString()
 				.replace(" ", "_") + "_concordance", true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 
@@ -1507,7 +1506,7 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 		return getCorpus() != null;
 	}
 
Index: tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/functions/WordCloud.java
===================================================================
--- tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/functions/WordCloud.java	(revision 527)
+++ tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/functions/WordCloud.java	(revision 528)
@@ -8,7 +8,6 @@
 import org.txm.chartsengine.core.results.IChartResult;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.index.core.functions.Index;
 import org.txm.index.core.functions.Line;
 import org.txm.lexicon.core.corpusengine.cqp.Lexicon;
@@ -213,7 +212,7 @@
 	}
 
 	@Override
-	public boolean _compute() {
+	protected boolean _compute(boolean update) {
 		// from corpus
 		if (source instanceof Corpus)	{// TODO: source must always be an Index because the corpus source produces an Index 
 			try {
@@ -236,7 +235,7 @@
 					corpus.addResult(index);
 				}
 
-				index.compute(monitor);
+				index.compute(false, monitor);
 				
 				index.addResult(this);
 					
@@ -264,7 +263,7 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 		return source != null;
 	}
 
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 527)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 528)
@@ -261,7 +261,7 @@
 
 						index.setParameters(query, properties, Fmin, Fmax, Tmax, nLines);
 
-						if (index.validateParameters() && index.isDirty()) {
+						if (index.canCompute() && index.isDirty()) {
 
 							title = NLS.bind(IndexUIMessages.IndexEditor_2, new Object[]{
 									query.getQueryString(), properties, index.getCorpus().getName()});
@@ -272,7 +272,7 @@
 							System.out.println(title);
 							Log.info("Start computing Index...");
 
-							index.compute(this);
+							index.compute(false, this);
 						} else {
 							return Status.CANCEL_STATUS;
 						}
@@ -380,7 +380,7 @@
 		paramArea.setLayout(new FormLayout());
 		
 		// info&navigation panel
-		final Composite infosArea = this.topToolBar.installGroup("Infos", "Informations and Navigation", null);
+		final Composite infosArea = this.topToolBar.installGroup("Infos", "Informations and Navigation", null, true);
 
 		Composite resultArea = this.getDisplayArea();
 
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 527)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 528)
@@ -9,12 +9,13 @@
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.Platform;
-import org.txm.Toolbox;
 import org.txm.chartsengine.core.messages.ChartsEngineCoreMessages;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.core.results.IChartResult;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMResult;
 import org.txm.utils.logger.Log;
 
 
@@ -139,6 +140,20 @@
 	}
 
 	/**
+	 * Gets a list of all installed chart creators for the specified result. 
+	 * @param resultDataType
+	 * @return
+	 */
+	public ArrayList<ChartCreator> getChartCreators(ChartResult result)	{
+		ArrayList<ChartCreator> chartCreators = new ArrayList<ChartCreator>();
+		HashMap<String, ChartCreator> map = this.chartCreators.get(result.getClass());
+		if(map != null)	{
+			chartCreators.addAll(map.values());
+		}
+		return chartCreators;
+	}
+	
+	/**
 	 * Adds a chart creator for the specified result data type and chart type.
 	 * @param resultDataType
 	 * @param chartCreator
@@ -288,6 +303,7 @@
 				
 				if(chartsEngineClass.equals(chartCreator.getChartsEngineClass()))	{
 					chartCreator.setFileNamePrefix(contributions[i].getAttribute("fileNamePrefix")); //$NON-NLS-1$
+					chartCreator.setChartType(contributions[i].getAttribute("chartType")); //$NON-NLS-1$
 					this.addChartCreator(chartCreator.getResultDataClass(), chartCreator, contributions[i].getAttribute("chartType")); //$NON-NLS-1$
 				}
 			}
@@ -369,6 +385,31 @@
 	 * @param outputFormat
 	 * @return
 	 */
+	// FIXME: original code
+//	public File createChartFile(TXMResult result, File file, String outputFormat)	{
+//		// FIXME : bad ? Switch the current charts engine output format, export the chart, and then roll back the output format
+//		String oldOutputFormat = this.outputFormat;
+//		this.setOutputFormat(outputFormat);
+//		
+//		
+//		Object chart = this.getChartCreator(result.getClass()).createChart(result);
+//		
+//		
+//		file = this.createChartFile(chart, file);
+//		//this.setOutputFormat(oldOutputFormat);
+//		this.outputFormat = oldOutputFormat;
+//		return file;
+//	}
+
+	
+	/**
+	 * Creates a chart according to the specified result and output format and writes it in the specified file.
+	 * @param result
+	 * @param file
+	 * @param outputFormat
+	 * @return
+	 */
+	//FIXME: check that modification works well
 	public File createChartFile(IChartResult result, File file, String outputFormat)	{
 		// FIXME : bad ? Switch the current charts engine output format, export the chart, and then roll back the output format
 		String oldOutputFormat = this.outputFormat;
@@ -378,6 +419,7 @@
 		this.outputFormat = oldOutputFormat;
 		return file;
 	}
+	
 
 	/**
 	 * Exports the chart to the specified file. Also crops the image according to the specified drawing area values.
@@ -511,4 +553,46 @@
 	public boolean isDirectComputing() {
 		return directComputing;
 	} 
+	
+	
+	/**
+	 * 
+	 * @param result
+	 * @param chartType
+	 * @return
+	 */
+	public Object createChart(ChartResult result, String chartType)	{
+		Object chart = null;
+		ChartCreator chartCreator = this.getChartCreator(result.getClass(), chartType);
+		if(chartCreator != null)	{
+			chart = chartCreator.createChart(result);
+		}
+		return chart;
+	}
+
+	/**
+	 * 
+	 * @param result
+	 * @return
+	 */
+	public Object createChart(ChartResult result)	{
+		return this.createChart(result, result.getChartType());
+	}
+
+	
+	
+	
+	/**
+	 * 
+	 * @param chart
+	 * @param result
+	 */
+	public void updateChart(Object chart, ChartResult result)	{
+		ChartCreator chartCreator = this.getChartCreator(result.getClass(), result.getChartType());
+		if(chartCreator != null)	{
+			chartCreator.updateChart(chart, result);
+		}
+	}
+	
+	
 }
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java	(revision 527)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java	(revision 528)
@@ -37,6 +37,11 @@
 	protected String fileNamePrefix;
 	
 	/**
+	 * A string representing the chart type created by this creator.
+	 */
+	protected String chartType;
+	
+	/**
 	 * 
 	 */
 	public ChartCreator() {
@@ -144,4 +149,20 @@
 	public String getFileNamePrefix() {
 		return fileNamePrefix;
 	}
+
+
+	/**
+	 * @return the chartType
+	 */
+	public String getChartType() {
+		return chartType;
+	}
+
+
+	/**
+	 * @param chartType the chartType to set
+	 */
+	public void setChartType(String chartType) {
+		this.chartType = chartType;
+	}
 }
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 527)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 528)
@@ -3,6 +3,8 @@
  */
 package org.txm.chartsengine.core.results;
 
+import org.txm.chartsengine.core.ChartCreator;
+import org.txm.chartsengine.core.ChartsEngine;
 import org.txm.core.results.TXMResult;
 
 /**
@@ -13,6 +15,16 @@
 public abstract class ChartResult extends TXMResult implements IChartResult {
 
 	/**
+	 * The chart object.
+	 */
+	protected Object chart;
+	
+	/**
+	 * The chart type;
+	 */
+	protected String chartType;
+	
+	/**
 	 * 
 	 * @param parent
 	 */
@@ -32,4 +44,74 @@
 	    return clone;
 	}
 	
+	/**
+	 * 
+	 * @param update
+	 * @return
+	 * @throws Exception
+	 */
+	public boolean computeChart(boolean update) throws Exception {
+
+		ChartCreator chartCreator = ChartsEngine.getCurrent().getChartCreator(this.getClass(), chartType);
+		if(chartCreator != null)	{
+			
+			if(update)	{
+				// FIXME: debug
+				System.err.println("ChartResult._compute(): updating chart.");
+				
+				chartCreator.updateChart(this.chart, this);
+			}
+			else	{
+				
+				// FIXME: debug
+				System.err.println("ChartResult._compute(): creating chart.");
+				
+				this.chart =  chartCreator.createChart(this);				
+			}
+			
+			this.dirty = false;
+			return true;
+			
+		}
+		return false;
+	}
+	
+	
+	
+	/**
+	 * @return the chart
+	 */
+	public Object getChart() {
+		return chart;
+	}
+
+
+	/**
+	 * @return the chartType
+	 */
+	public String getChartType() {
+		return chartType;
+	}
+
+
+	/**
+	 * @param chartType the chartType to set
+	 */
+	public void setChartType(String chartType) {
+		// set to null to match the way that the chart engine returns the creator
+		if(chartType.equals(this.getClass().getName()))	{
+			chartType = null;
+		}
+		this.chartType = chartType;
+	}
+	
+	
+
+	// FIXME
+//	public Object createChart(IProgressMonitor monitor, String chartType)	{
+//		Object chart = null;
+//		ChartCreator chartCreator = ChartsEngine.getCurrent().getChartCreator(this.getClass(), chartType);
+//		return chart;
+//	}
+	
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/selection/Selection.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/selection/Selection.java	(revision 527)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/selection/Selection.java	(revision 528)
@@ -32,11 +32,9 @@
 import java.util.HashMap;
 import java.util.List;
 
-import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
-
 import org.txm.metadatas.Metadata;
 import org.txm.metadatas.MetadataGroup;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
@@ -491,12 +489,12 @@
 	}
 
 	@Override
-	public boolean validateParameters() {
+	public boolean canCompute() {
 		return corpus != null;
 	}
 
 	@Override
-	public boolean _compute() throws Exception {
+	protected boolean _compute(boolean update) throws Exception {
 		System.out.println("Selection.compute() not implemented");
 		return false;
 	}
